﻿@using System.Web.UI.WebControls;

@using DevExpress.Web.Mvc;
@using DevExpress.Web.Mvc.UI;
@using DevExpress.Utils;

@using Portal.Models.Receiving.TruckReceiving;
@using Toyota.Common.Web.Html;
@using Toyota.Common.Web.Html.Helper
@using Toyota.Common.Web.MVC;

@Html.DevExpress().GridView(
setting =>
{
    setting.Name = "GridTruckReceiving";
    setting.KeyFieldName = "MANIFEST_NO";
    setting.CallbackRouteValues = new { Controller = "TruckReceiving", Action = "PartialData" };
    //setting.ClientSideEvents.Init = "gridDeliveryInvoice_Init";
    //setting.ClientSideEvents.CustomButtonClick = "func";
    //setting.ClientSideEvents.Init = "grid_init";
    setting.ClientSideEvents.BeginCallback = "OnBeginCallbackGrid";
   // setting.ClientSideEvents.EndCallback = "OnEndCallbackGrid";
    setting.Styles.Header.HorizontalAlign = HorizontalAlign.Center;
    setting.Width = Unit.Percentage(100);

    setting.Settings.ShowFilterRow = true;
    setting.Settings.ShowFilterRowMenu = true;
    setting.SettingsBehavior.AllowSelectSingleRowOnly = true;
    setting.SettingsBehavior.AllowSelectByRowClick = false;
    setting.CommandColumn.ClearFilterButton.Visible = true;
    setting.CommandColumn.ShowSelectCheckbox = false;
    setting.CommandColumn.Visible = false;
    setting.CommandColumn.Width = Unit.Pixel(20);
    setting.SettingsPager.PageSizeItemSettings.Visible = true;
    setting.SettingsPager.PageSizeItemSettings.Items = new string[] { "10", "30", "50", "100" };
    setting.SettingsPager.PageSizeItemSettings.Caption = "Page size";
    setting.Settings.HorizontalScrollBarMode = ScrollBarMode.Hidden;
    setting.SettingsPager.FirstPageButton.Visible = true;
    setting.SettingsPager.LastPageButton.Visible = true;

    setting.HtmlDataCellPrepared = (sender, e) =>
    {
        if (e.DataColumn.FieldName == "STATUS")
        {
            //if (e.CellValue.ToString() == "Completed")
            //{
            //    e.Cell.BackColor = System.Drawing.Color.LightGreen;
            //    e.Cell.ForeColor = System.Drawing.Color.Black;
            //}
            //else
            //{
            //    e.Cell.BackColor = System.Drawing.Color.Red;
            //    e.Cell.ForeColor = System.Drawing.Color.Black;
            //}
            
            switch(e.CellValue.ToString())
            {
                case "Completed":
                    e.Cell.BackColor = System.Drawing.Color.LightGreen;
                    e.Cell.ForeColor = System.Drawing.Color.Black;
                break;
                case "Ordered":
                    e.Cell.BackColor = System.Drawing.Color.Yellow;
                    e.Cell.ForeColor = System.Drawing.Color.Black;
                break;
                case "Shortage":
                    e.Cell.BackColor = System.Drawing.Color.Red;
                    e.Cell.ForeColor = System.Drawing.Color.White;
                    break;
                case "Delayed":
                    e.Cell.BackColor = System.Drawing.Color.Red;
                    e.Cell.ForeColor = System.Drawing.Color.White;
                break;
            }
        }

        if (e.DataColumn.FieldName == "REMARKED")
        {
            if (e.CellValue.ToString() != "0")
            {
                e.Cell.BackColor = System.Drawing.Color.Yellow;
                e.Cell.ForeColor = System.Drawing.Color.Black;
            }
        }
    };
    
    //setting.CommandColumn.SetHeaderTemplateContent(
    //c =>
    //{
    //    Html.DevExpress().CheckBox(
    //            chckBox =>
    //            {
    //                chckBox.Name = "SelectAllCheckBox";
    //                //chckBox.Width = 16;
    //                //chckBox.Properties.ClientSideEvents.CheckedChanged = "function(s, e){ GridServiceAcceptance.SelectAllRowsOnPage(chkAllRecord.GetChecked());}";
    //                //chckBox.Properties.ClientSideEvents.CheckedChanged = "CheckChange";
    //                //chckBox.Checked = c.Grid.Selection.Count > 1;
    //                chckBox.Properties.ClientSideEvents.CheckedChanged = string.Format("function(s, e) {{ if(s.GetChecked()) {0}.SelectRows(); else {0}.UnselectRows(); }}", setting.Name);
    //                chckBox.Checked = c.Grid.Selection.Count == c.Grid.VisibleRowCount;
    //            }
    //        ).Render();
    //});

    
    setting.Columns.Add(col =>
    {
        col.FieldName = "MANIFEST_NO";
        col.Caption = "Manifest Number";
        col.Width = 90;
        col.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
        col.SetDataItemTemplateContent(container =>
        {
            Html.DevExpress().HyperLink(hlSettings =>
            {
                hlSettings.Name = string.Format("hlo_{0}", (container as GridViewDataItemTemplateContainer).VisibleIndex);
                hlSettings.NavigateUrl = "javascript:void(0)";
                hlSettings.Properties.ClientSideEvents.Click = string.Format("function(s, e) {{ openpage('{0}','{1}','{2}','{3}','{4}','{5}'); }}", DataBinder.Eval(container.DataItem, "MANIFEST_NO"), DataBinder.Eval(container.DataItem, "SUPPLIER_PLANT_CD"), DataBinder.Eval(container.DataItem, "SUPPLIER_CODE"), DataBinder.Eval(container.DataItem, "SUPPLIER_NAME"), DataBinder.Eval(container.DataItem, "RCV_PLANT_CD"), DataBinder.Eval(container.DataItem, "DOCK_CD"));
                hlSettings.Properties.Text = (container as GridViewDataItemTemplateContainer).Text;
            }).Render();
        });

    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "ORDER_NO";
        col.Caption = "Order No";
        col.Width = 110;
        col.Visible = false;
        col.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;

    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "P_LANE_CD";
        col.Caption = "P_LANE_CD";
        col.Width = 110;
        col.Visible = false;
        col.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;

    });
    
    
    setting.Columns.Add(col =>
    {
        col.FieldName = "RCV_PLANT_CD";
        col.Caption = "RCV_PLANT_CD";
        col.Width = 110;
        col.Visible = false;
        col.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;

    });
   
    setting.Columns.AddBand(
    columnBand =>
    {
        columnBand.Caption = "Supplier";
        //columnBand.Width = Unit.Percentage(50);
        columnBand.Columns.Add(
            column =>
            {

                column.Caption = "Plant";
                column.Name = "SUPPLIER_PLANT_CD";
                column.FieldName = "SUPPLIER_PLANT_CD";
                column.Width = 40;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
            }
            );

        columnBand.Columns.Add(
            column =>
            {
                column.Caption = "Dock";
                column.Name = "DOCK_CD";
                column.FieldName = "DOCK_CD";
                column.Visible = false;
                column.Width = 40;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
            }
            );

        columnBand.Columns.Add(
            column =>
            {
                column.Caption = "Code";
                column.Name = "SUPPLIER_CODE";
                column.FieldName = "SUPPLIER_CODE";
                column.Width = 40;
                column.CellStyle.HorizontalAlign = HorizontalAlign.Left;
                column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
            }
            );

        columnBand.Columns.Add(
           column =>
           {
               column.Caption = "Name";
               column.Name = "SUPPLIER_NAME";
               column.FieldName = "SUPPLIER_NAME";

               column.CellStyle.HorizontalAlign = HorizontalAlign.Left;
               column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
               column.SetDataItemTemplateContent(container =>
               {
                   Html.DevExpress().HyperLink(hlSettings =>
                   {
                       hlSettings.Name = string.Format("hl_{0}", (container as GridViewDataItemTemplateContainer).VisibleIndex);
                       hlSettings.NavigateUrl = "javascript:void(0)";
                       hlSettings.Properties.ClientSideEvents.Click = string.Format("function(s, e) {{ OpenUrl('{0}', '{1}', '{2}', '{3}'); }}", DataBinder.Eval(container.DataItem, "DOCK_CD"), DataBinder.Eval(container.DataItem, "RCV_PLANT_CD"), DataBinder.Eval(container.DataItem, "SUPPLIER_CODE"), DataBinder.Eval(container.DataItem, "SUPPLIER_PLANT_CD"));
                       hlSettings.Properties.Text = (container as GridViewDataItemTemplateContainer).Text;
                   }).Render();
               });
           }
           );
    });


    setting.Columns.AddBand(
   columnBand =>
   {
       columnBand.Caption = "Manifest";
       //columnBand.Width = Unit.Percentage(50);
       columnBand.Columns.Add(
           column =>
           {

               column.Caption = "Total";
               column.Name = "TOTAL_ITEM";
               column.FieldName = "TOTAL_ITEM";
               column.Width = 40;
               column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
               column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
               column.SetDataItemTemplateContent(container =>
               {
                   Html.DevExpress().HyperLink(hlSettings =>
                   {
                       hlSettings.Name = string.Format("hs_{0}", (container as GridViewDataItemTemplateContainer).VisibleIndex);
                       hlSettings.NavigateUrl = "javascript:void(0)";
                       hlSettings.Properties.ClientSideEvents.Click = string.Format("function(s, e) {{ OpenUrlSum('{0}'); }}", DataBinder.Eval(container.DataItem, "MANIFEST_NO"));
                       hlSettings.Properties.Text = (container as GridViewDataItemTemplateContainer).Text;
                   }).Render();
               });
           }
           );

       columnBand.Columns.Add(
           column =>
           {
               column.Caption = "Completed";
               column.Name = "COMPLETED";
               column.FieldName = "COMPLETED";
               column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
               column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
               column.Width = 50;
           }
           );

       columnBand.Columns.Add(
           column =>
           {
               column.Caption = "Uncompleted";
               column.Name = "INCOMPLETE";
               column.FieldName = "INCOMPLETE";
               column.Width = 50;
               column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
               column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
           }
           );
   });



    setting.Columns.Add(
                        column =>
                        {
                            column.Caption = "Rcv Status";
                            column.Name = "STATUS";
                            column.FieldName = "STATUS";
                            column.Width = Unit.Pixel(70);
                            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
                            column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
                            column.ColumnType = MVCxGridViewColumnType.ComboBox;
                            var combosetting = column.PropertiesEdit as ComboBoxProperties;
                            combosetting.Items.Add("Shortage");
                            combosetting.Items.Add("Completed");
                            column.SetDataItemTemplateContent(container =>
                            {
                                Html.DevExpress().HyperLink(hlSettings =>
                                {
                                    hlSettings.Name = string.Format("hp_{0}", (container as GridViewDataItemTemplateContainer).VisibleIndex);
                                    hlSettings.NavigateUrl = "javascript:void(0)";
                                    hlSettings.Properties.ClientSideEvents.Click = string.Format("function(s, e) {{ OpenUrlPart('{0}'); }}", DataBinder.Eval(container.DataItem, "MANIFEST_NO"));
                                    hlSettings.Properties.Text = (container as GridViewDataItemTemplateContainer).Text;
                                }).Render();
                            });
                        }
     );

    setting.Columns.Add(
    col =>
    {
        col.Settings.ShowFilterRowMenu = DefaultBoolean.False;
        col.Settings.AllowAutoFilter = DefaultBoolean.False;
        col.Caption = "Remark";
        col.FieldName = "REMARKED";
        col.Width = Unit.Pixel(50);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.SetDataItemTemplateContent(container =>
        {
            ViewContext.Writer.Write(
             "<a href=\"javascript:void(0)\" onClick=\"remark('" + DataBinder.Eval(container.DataItem, "MANIFEST_NO") + "','" + DataBinder.Eval(container.DataItem, "ORDER_NO") + "')\">"
             );
            Html.DevExpress().Image(
                 img =>
                 {
                     img.Properties.ImageAlign = ImageAlign.Middle;
                     img.ImageUrl = "~/Content/Images/remark.png";
                 }).Render();
            ViewContext.Writer.Write(
                "</a>"
             );
        });
    }
 );



}).Bind(Model.GetModel<TruckReceivingDetailModel>().truckReceivingListData).GetHtml()